##############################################################################
#
# Copyright (c) 2003 gocept gmbh & co. kg. All rights reserved.
#
# See also LICENSE.txt
#
##############################################################################
"""CMF link checker tool
$Id: Install.py,v 1.3 2003/12/17 19:18:27 ctheune Exp $"""

from Products.CMFLinkChecker.LinkCheckerTool import LinkCheckerTool
from Products.CMFCore.utils import getToolByName
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFLinkChecker import linkchecker_globals 
from StringIO import StringIO
import string

def install(self):
    out=StringIO()

    if not hasattr(self, "_isPortalRoot"):
        print >> out, "Must be installed in a CMF Site (read Plone)"
        return
   
    print >> out, 'Installing portal_linkchecker'

    self.portal_actions.manage_aproviders(apname="portal_linkchecker", add_provider=1, REQUEST=None)
    self.manage_addProduct['CMFLinkChecker'].manage_addTool(type='CMF Linkchecker Tool')

    self.portal_catalog.addIndex("portal_linkchecker_uid", "FieldIndex")
    self.left_slots = list(self.left_slots) + ['here/portlet_links/macros/portlet',]

    # XXX Register with form validation

    # Register configlet
    portal_conf=getToolByName(self,'portal_controlpanel')
    portal_conf.registerConfiglet( 'Link Checker'
                 , 'CMFLinkChecker'      
                 , 'string:${portal_url}/lc_configlet' 
                 , ''                   # a condition   
                 , 'Manage portal'      # access permission
                 , 'Products'           # section to which the configlet should be added: 
                                        #(Plone,Products,Members) 
                 , 1                    # visibility
                 , 'CMFLinkChecker'
                 , 'plone_images/site_icon.gif' # icon in control_panel, put your own icon in the 
                                                # /skins folder of your product and change 
                                                #'site_icon.gif' to 'yourfile'
                 , 'An utility for monitoring external links in your site. Helps you to avoid dead links.'
                 , None
                 )  

    # Register skins
    addDirectoryViews(self.portal_skins, 'skins', linkchecker_globals)
    skins = self.portal_skins.getSkinSelections()
    for skin in skins:
        path = self.portal_skins.getSkinPath(skin)
        path = map(string.strip, path.split(','))
        if 'linkchecker' not in path:
            try:
                    path.insert(path.index('content'), 'linkchecker')
            except ValueError:
                    path.append('linkchecker')
            path = ','.join(path)
            self.portal_skins.addSkinSelection(skin, path)
            print >> out, skin + ",",
        else:
            print >> out, "skipped" + skin,


    print >> out, 'Successfully installed CMFLinkChecker'

    return out.getvalue()

def uninstall(self):
   portal_conf=getToolByName(self,'portal_controlpanel')
   portal_conf.unregisterConfiglet('CMFLinkChecker')

   portal_cat = getToolByName(self, 'portal_catalog')
   portal_cat.delIndex('portal_linkchecker_uid')
